;
;  ⨢ .  1.0
; 楤 ᮫쭮 /뢮
;
;  ᮧ : 09.09.2001
;  ᫥ 䨪樨 : 19.09.2001
;
; Copyright (c) 2001 ᨫ쭨 
;

TITLE MemEdit v1.0 - Console input/output routines


public	OutChar
public	OutCharDirect
public	FlushKbd
public	CheckKbd
public	ClrScr
public	GotoXY
public	GetXY
public	SetCursorType
public	ShowCursor
public	HideCursor
public	WriteString
public	OutHexDWord
public	OutHexWord
public	OutHexByte
public	OutHexDigit
public	WaitRetrace
public	OutCrLf
public	ClrEol
public	Sound
public	NoSound

public	text_attr


code	segment word public use16 'code'
	assume	cs:code, ds:code, ss:nothing, es:nothing
	.386

text_attr	db 07h


;
; 㭪: OutChar
;
; 祭: 뢮  ࠭  ᨬ
;
;  室: al
;
OutChar	proc	near
	push	ax
	push	bx
	push	bp
	cmp	al, 7
	je	outnow
	cmp	al, 8
	je	outnow
	cmp	al, 13
	je	outnow
	cmp	al, 10
	je	outnow
	push	ax
	push	cx
	mov	ax, 0920h
	xor	bh, bh
	mov	bl, text_attr
	mov	cx, 1
	int	10h
	pop	cx
	pop	ax
outnow:	mov	ah, 0Eh
	xor	bx, bx
	int	10h
	pop	bp
	pop	bx
	pop	ax
	ret
OutChar	endp


;
; 㭪: OutCharDirect
;
; 祭: 뢮  ࠭  ᨬ  -  ᯥ樠쭮
; 樨
;
;  室: al
;
OutCharDirect	proc	near
	push	ax
	push	bx
	push	dx
	push	es
	mov	bl, al
	mov	bh, cs:[text_attr]
	mov	ax, 0B800h
	mov	es, ax
	call	GetXY			; dh=Y, dl=X
	push	dx
	mov	al, dh
	mov	dh, 0
	mov	ah, 80
	mul	ah
	add	ax, dx
	shl	ax, 1
	xchg	ax, bx
	mov	word ptr es:[bx], ax
	pop	dx
	inc	dl
	cmp	dl, 80
	jb	@1
	inc	dh
	mov	dl, 0
@1:	call	GotoXY
	pop	es
	pop	dx
	pop	bx
	pop	ax
	ret
OutCharDirect	endp


;
; 㭪: FlushKbd
;
; 祭: ⪠   (ணࠬ)
;
FlushKbd	proc	near
	push	es
	push	ax
	xor	ax, ax
	mov	es, ax
	cli
	mov	al, es:[041Ah]
	mov	es:[041Ch], al
	sti
	pop	ax
	pop	es
	ret
FlushKbd	endp


;
; 㭪: CheckKbd
;
; 祭: ஢ઠ    稥   ⠭ ᨬ
;
;  室 :
;   al=00h, ZF=1, ᫨   
;     =FFh, ZF=0, ᫨     ⠭ ᨬ
;
CheckKbd	proc	near
	push	es
	push	ax
	xor	ax, ax
	mov	es, ax
	cli
	mov	al, es:[041Ah]
	cmp	al, es:[041Ch]
	sti
	pop	ax
	je	_empty
	mov	al, 0FFh
	jmp	short _ret
_empty:	xor	al, al
_ret:	pop	es
	or	al, al
	ret
CheckKbd	endp


;
; 㭪: ClrScr
;
; 祭: ⪠ ࠭
;
ClrScr	proc	near
	push	es
	push	ax
	push	cx
	push	di
	mov	ax, 0B800h
	mov	es, ax
	mov	al, 20h
	mov	ah, text_attr
	xor	di, di
	mov	cx, 2000
	cld
	rep	stosw
	push	dx
	xor	dx, dx
	call	GotoXY
	pop	dx
	pop	di
	pop	cx
	pop	ax
	pop	es
	ret
ClrScr	endp


;
; 㭪: GotoXY
;
; 祭: ⠭ ⥪饩 樨   ࠭
;
;  室:
;   dh -  ப (0 - ࢠ, 1 -   . .)
;   dl -  ⮫ (0 - , 1 - ன  . .)
;
GotoXY	proc	near
	push	ax
	push	bx
	mov	ah, 02h
	xor	bx, bx
	int	10h
	pop	bx
	pop	ax
	ret
GotoXY	endp


;
; 㭪: GetXY
;
; 祭: 祭 ⥪饩 樨   ࠭
;
;  室: 祣
;
;  室:
;   dh -  ப (0 - ࢠ, 1 -   . .)
;   dl -  ⮫ (0 - , 1 - ன  . .)
;
GetXY	proc	near
	push	ax
	push	bx
	push	cx
	mov	ah, 03h
	xor	bx, bx
	int	10h
	pop	cx
	pop	bx
	pop	ax
	ret
GetXY	endp


;
; 㭪: SetCursorType
;
; 祭: ⠭  
;
;  室:
;   ch - 砫쭠 ᪠- 
;   cl - 筠 ᪠- 
;
SetCursorType	proc	near
	push	ax
	mov	ah, 01h
	int	10h
	pop	ax
	ret
SetCursorType	endp


;
; 㭪: ShowCursor
;
; 祭: 祭  饣   ࠭
;
ShowCursor	proc	near
	push	cx
	mov	cx, 0607h
	call	SetCursorType
	pop	cx
	ret
ShowCursor	endp


;
; 㭪: HideCursor
;
; 祭: ⪫祭  饣   ࠭
;
HideCursor	proc	near
	push	cx
	mov	cx, 2020h
	call	SetCursorType
	pop	cx
	ret
HideCursor	endp


;
; 㭪: WriteStringZero
;
; 祭: 뢮 ப, 稢饩 㫥 (ASCIIZ)
;
;  室:
;   ds:si -  ப
;
WriteString	proc	near
	push	ax
	push	si
nxtchr:	lodsb
	or	al, al
	jz	endout
	call	OutChar
	jmp	short nxtchr
endout:	pop	si
	pop	ax
	ret
WriteString	endp


;
; 㭪: OutHexDWord
;
; 祭: 뢮 祭  ᫮  ⭠筮 ⥬ ᫥
;
;  室: eax
;
OutHexDWord	proc	near
	ror	eax, 16
	call	OutHexWord
	ror	eax, 16
	jmp	OutHexWord
OutHexDWord	endp


;
; 㭪: OutHexWord
;
; 祭: 뢮 祭 ᫮  ⭠筮 ⥬ ᫥
;
;  室: ax
;
OutHexWord	proc	near
	xchg	al, ah
	call	OutHexByte
	xchg	al, ah
	jmp	OutHexByte
OutHexWord	endp


;
; 㭪: OutHexByte
;
; 祭: 뢮 祭   ⭠筮 ⥬ ᫥
;
;  室: al
;
OutHexByte	proc	near
	push	ax
	push	ax
	shr	al, 4
	cmp	al, 10
	sbb	al, 69h
	das
	call	OutChar
	pop	ax
	and	al, 0Fh
	cmp	al, 10
	sbb	al, 69h
	das
	call	OutChar
	pop	ax
	ret
OutHexByte	endp


;
; 㭪: OutHexDigit
;
; 祭: 뢮  ⭠筮   ࠭
;
;  室:
;     al -   뢮
;
OutHexDigit	proc	near
	push	ax
	and	al, 0Fh
	cmp	al, 10
	sbb	al, 69h
	das
	call	OutChar
	pop	ax
	ret
OutHexDigit	endp


;
; 楤: WaitRetrace
;
; 祭:  砫 ⨪쭮 ࠧ⪨  
;
WaitRetrace	proc	near
	push	ax
	push	dx
	mov	dx, 03DAh
wvrend:	in	al, dx
	test	al, 8
	jnz	wvrend
wnxtvr:	in	al, dx
	test	al, 8
	jz	wnxtvr
	pop	dx
	pop	ax
	ret
WaitRetrace	endp


;
; 楤: OutCrLf
;
; 祭: ॢ ப
;
OutCrLf	proc	near
	push	ax
	call	GetXY
	inc	dh
	mov	dl, 0
	call	GotoXY
	pop	ax
	ret
OutCrLf	endp


;
; 楤: ClrEol
;
; 祭: ⪠ ⥪饩 ப  樨   ;  
; ⮬  ।, ᯮ ﬠ   
;
ClrEol	proc	near
	push	es
	push	ax
	push	cx
	push	dx
	push	di
	mov	ax, 0B800h
	mov	es, ax
	call	GetXY		; dh=Y, dl=X
	mov	al, dh
	mov	dh, 0
	push	dx
	mov	ah, 80
	mul	ah
	add	ax, dx
	shl	ax, 1
	mov	di, ax		; di = (Y*80+X) * 2
	pop	dx
	neg	dx
	add	dx, 80
	mov	cx, dx		; cx = 80 - X
	mov	ah, text_attr
	mov	al, 0		; ᨬ-⥫
	cld
	cli
	rep	stosw
	sti
	pop	di
	pop	dx
	pop	cx
	pop	ax
	pop	es
	ret
ClrEol	endp


;
; 楤: Sound
;
; 祭: 祭 ⠭       㪠
;    ᯮ짮 奬 ⠩ 8253/8254. 
; 㪠     19 !
;
;  室:
;   ax -  砭, 
;
Sound	proc	near
	push	eax
	push	ebx
	push	edx
	movzx	ebx, ax
	mov	al, 10110110b
	out	43h, al
	mov	eax, 1193180
	cdq
	div	ebx
	out	42h, al
	mov	al, ah
	call	_ret
	out	42h, al
	in	al, 61h
	or	al, 3
	out	61h, al
	pop	edx
	pop	ebx
	pop	eax
_ret:	ret
Sound	endp


;
; 楤: NoSound
;
; 祭: ⪫祭    ⠭
;
NoSound	proc	near
	push	ax
	in	al, 61h		;  ⮢ 0  1   B 奬
	and	al, 0FCh	; ணࠬ㥬 ਩ 䥩 (PPI)
	out	61h, al	
	pop	ax
	ret
NoSound	endp

code	ends
	end
