;
;  ⨢ .  1.0
;  
;
; ⥬ ॡ :
;    IBM PC  ᮢ⨬
;    80386+
;    MS-DOS 2.0+
;
;  ᮧ : 09.09.2001
;  ᫥ 䨪樨 : 20.09.2001
;
; Copyright (c) 2001 ᨫ쭨 
;

TITLE MemEdit v1.0 - Main module

include	console.inc


code	segment word public use16 'code'
	assume	cs:code, ds:code, ss:nothing, es:nothing
	org	100h
	.386

start:	jmp	realstart

szCopyright	label	byte
	db	13, 10, 13, 10
	db	"----------------------------------------", 13, 10
	db	'  Program "MemoryEditor". Version 1.00  ', 13, 10
	db	"     Copyright (c) Krasilnikov Ivan     ", 13, 10
	db	"             September, 2001            ", 13, 10
	db	"----------------------------------------", 13, 10
	db	13, 10, 0


CurSegment	dw ?		; 㥬 ᥣ (ᥣ 
				; 孥 ப)
CurLine		dw ?		;  ப
CurCol		dw ?		; 騩 ⮫ (0..31,  ⮢)

szTitle		db " ⨢ ", 0
szHelp		db "F5: 室          ESC/F10: 室", 0


;
;  樠 ணࠬ
;
realstart:
	call	initcon			; 樠 ᮫

	mov	CurSegment, 0
	mov	CurLine, 0
	mov	CurCol, 0


;
; "" 横
;
forever:call	RedrawScreen
	call	CheckKbd
	jz	forever
	xor	ax, ax
	int	16h
	cmp	al, 27
	je	exit_forever
	cmp	al, 0
	je	ext_ascii
	call	ascii2hex
	jc	forever
	jmp	edit_digit

ext_ascii:
	cmp	ah, 3Fh			; F5
	je	mem_goto
	cmp	ah, 44h			; F10
	je	exit_forever
	cmp	ah, 4Dh			; ->
	je	move_forward
	cmp	ah, 4Bh			; <-
	je	move_backward
	cmp	ah, 50h			; 
	je	move_lnforward
	cmp	ah, 48h			; 
	je	move_lnbackward
	cmp	ah, 51h			; PgDn
	je	move_pgforward
	cmp	ah, 49h			; PgUp
	je	move_pgbackward
	cmp	ah, 47h			; Home
	je	move_home
	cmp	ah, 4Fh			; End
	je	move_end
	jmp	forever

;
; ॢ ASCII-ᨬ (0-9,A-F,a-f)  ⭠ 
;
;  室	al
;
;  室	al
;
; ਬ砭	᫨ ᨬ  室    ८ࠧ,  CF=1,
;		 CF=0
;
ascii2hex	proc
	cmp	al, 'a'
	jb	@1
	cmp	al, 'z'
	ja	@1
	sub	al, 32
@1:	cmp	al, '0'
	jb	@2
	cmp	al, '9'
	ja	@2
	sub	al, '0'
	jmp	_ret_ok
@2:	cmp	al, 'A'
	jb	@3
	cmp	al, 'F'
	ja	@3
	sub	al, ('A'-10)
_ret_ok:clc
	ret
@3:	stc
	ret
ascii2hex	endp

;
; 室  㪠 짮⥫ ᥣ ⨢ 
;
mem_goto	proc
	mov	dx, 0100h
	call	GotoXY
	mov	text_attr, 1Bh
	lea	si, str1
	call	WriteString
	call	GotoXY
	call	ShowCursor

	mov	cx, 4
	mov	dest, 0

@1:	xor	ax, ax
	int	16h
	cmp	al, 27
	je	@3
	cmp	al, 13
	je	@2
	mov	bl, al
	call	ascii2hex
	jc	@1
	mov	ah, 0
	shl	dest, 4
	add	dest, ax
	mov	al, bl
	call	OutChar
	loop	@1

@2:	mov	ax, dest
	mov	CurSegment, ax
	mov	CurLine, 0
	mov	CurCol, 0
	cmp	CurSegment, 0FFE9h
	jb	@3
	mov	CurSegment, 0FFE9h
@3:	jmp	forever

str1	db "  ", 0
dest	dw ?
mem_goto	endp

;
; ஢   樨 
;
;  室	al[0:4] -  
;
edit_digit:
	push	es
	mov	bx, ax
	and	bl, 0Fh
	mov	ax, CurSegment
	add	ax, CurLine
	mov	es, ax
	mov	cx, CurCol
	mov	di, cx
	shr	di, 1
	mov	al, es:[di]
	test	cx, 1
	jz	edtdgt_pos_a
	and	al, 0F0h
	or	al, bl
	jmp	edtdgt_ins
edtdgt_pos_a:
	and	al, 0Fh
	shl	bl, 4
	or	al, bl
edtdgt_ins:
	stosb
	pop	es
;	jmp	move_forward


;
; ६饭  ।   
;
move_forward:
	inc	CurCol
	cmp	CurCol, 32
	jb	movefwrd_1
	mov	CurCol, 0
	inc	CurLine
	cmp	CurLine, 23
	jb	movefwrd_1
	dec	CurLine
	inc	CurSegment
	cmp	CurSegment, 0FFE9h
	jae	move_end
movefwrd_1:
	jmp	forever


;
; ६饭  ।   ப
;
move_lnforward:
	inc	CurLine
	cmp	CurLine, 23
	jb	movelnfwrd_1
	dec	CurLine
	inc	CurSegment
	cmp	CurSegment, 0FFE9h
	jae	move_end
movelnfwrd_1:
	jmp	forever

;
; ६饭  ।   ࠭  (22 ப)
;
move_pgforward:
	mov	ax, CurSegment
	cmp	ax, 0FFE9h
	jae	movepgfwrd_1
	add	ax, 22
	cmp	ax, 0FFE9h
	jbe	movepgfwrd_2
movepgfwrd_1:
	mov	ax, 0FFE9h
movepgfwrd_2:
	mov	CurSegment, ax
	jmp	forever


;
; ६饭     
;
move_backward:
	cmp	CurCol, 0
	je	movebkwd_prevln
	dec	CurCol
	jmp	forever
movebkwd_prevln:
	cmp	CurLine, 0
	je	movebkwd_prevlnsg
	mov	CurCol, 31
	dec	CurLine
	jmp	forever
movebkwd_prevlnsg:
	cmp	CurSegment, 0
	je	forever
	dec	CurSegment
	mov	CurCol, 31
	jmp	forever

;
; ६饭     ப
;
move_lnbackward:
	cmp	CurLine, 0
	je	movelnbkwd_1
	dec	CurLine
	jmp	forever
movelnbkwd_1:
	cmp	CurSegment, 0
	je	move_home
	dec	CurSegment
	jmp	forever


;
; ६饭     ࠭  (22 ப)
;
move_pgbackward:
	mov	ax, CurSegment
	cmp	ax, 22
	ja	movepgbkwrd_1
	mov	ax, 22
movepgbkwrd_1:
	sub	ax, 22
	mov	CurSegment, ax
	jmp	forever


;
; ६饭   砫 
;
move_home:
	mov	CurSegment, 0
	mov	CurLine, 0
	mov	CurCol, 0
	jmp	forever

;
; ६饭    
;
move_end:
	mov	CurSegment, 0FFE9h
	mov	CurLine, 22
	mov	CurCol, 31
	jmp	forever



;
; 室  ணࠬ  ( ⨨ ESC  F10)
;
exit_forever:
	call	WaitRetrace
	mov	text_attr, 07h
	call	ClrScr
	call	ShowCursor
	call	FlushKbd
	mov	al, 0
	call	exit


;
; 楤	initcon
;
; ᠭ	 楤 室  㯯 樠樨.  ।祭
;		 樠樨 ᮫ (࠭, ): ⠭
;		०, ⪠ ࠭   
;
initcon	proc	near
	mov	ah, 0Fh		;  ⥪饣 ०
	int	10h
	cmp	al, 03h
	je	vmode_3
	mov	ax, 0003h	; ⠭ ० 03h, ᫨   
	int	10h		; ⠭
vmode_3:mov	ax, 0500h	; 롮 㫥 ࠭
	int	10h
	call	WaitRetrace
	mov	text_attr, 1Bh
	call	ClrScr
	call	ShowCursor
	call	FlushKbd
	ret
initcon	endp


;
; 楤	RedrawScreen
;
; ᠭ	ᮢ ᥣ ࠭, 樮஢ 
;
RedrawScreen	proc
	call	WaitRetrace
	call	HideCursor
	call	RedrawUpbar
	call	RedrawDownbar
	xor	ax, ax
@1:	call	RedrawLine
	inc	ax
	cmp	ax, 23
	jb	@1
	call	UpdateCursorPos
	call	ShowCursor
	call	WaitRetrace
	ret
RedrawScreen	endp


;
; 楤	RedrawUpbar
;
; ᠭ	ᮢ ப ﭨ ()
;
; 蠥	eax, ebx, dx, si
;
RedrawUpbar	proc
	xor	dx, dx
	call	GotoXY
	mov	text_attr, 30h
	call	ClrEol
	lea	si, szTitle
	call	WriteString
	mov	dl, 40
	call	GotoXY
	movzx	eax, CurLine
	movzx	ebx, CurSegment
	add	eax, ebx
	shl	eax, 4
	mov	bx, CurCol
	shr	bx, 1
	add	eax, ebx		; eax - ᮫⭮ ᬥ饭  
	ror	eax, 16
	call	OutHexDigit
	ror	eax, 16
	call	OutHexWord
	ret
RedrawUpbar	endp


;
; 楤	RedrawDownbar
;
; ᠭ	ᮢ ப 㭪樮  ()
;
; 蠥	dx, si
;
RedrawDownbar	proc
	mov	dx, 1800h
	call	GotoXY
	mov	text_attr, 30h
	call	ClrEol
	lea	si, szHelp
	call	WriteString
	ret
RedrawDownbar	endp


;
; 楤	RedrawLine
;
; ᠭ	ᮢ  ப ࠭ (ᮤন )
;
;  室	al =  ப (0..22)
;
RedrawLine	proc
	push	ax
	push	dx
	push	es
	mov	text_attr, 1Bh
	mov	dh, al
	inc	dh
	mov	dl, 0
	call	GotoXY

	mov	ah, 0
	add	ax, CurSegment
	mov	es, ax
	call	OutHexWord
	mov	al, '0'
	call	OutChar
	lea	si, szStr1
	call	WriteString

	xor	si, si
outhex_cycle:
	mov	al, es:[si]
	inc	si
	call	OutHexByte
	mov	al, ' '
	call	OutChar
	cmp	si, 4
	jne	@1
	call	OutChar
@1:	cmp	si, 12
	jne	@2
	call	OutChar
@2:	cmp	si, 8
	jne	@3
	mov	al, ''
	call	OutChar
	mov	al, ' '
	call	OutChar
@3:	cmp	si, 16
	jb	outhex_cycle
	call	OutChar
	call	OutChar
	xor	si, si
outascii_cycle:
	mov	al, es:[si]
	inc	si
	call	OutCharDirect
	cmp	si, 16
	jb	outascii_cycle

	pop	es
	pop	dx
	pop	ax
	ret

szStr1	db ":  ", 0

RedrawLine	endp


;
; 楤	UpdateCursorPos
;
; ᠭ	६饭   ।㥬 
;
; 蠥	ax, bx, dx
;
UpdateCursorPos	proc
	mov	ax, CurLine
	inc	ax
	mov	dh, al
	mov	ax, CurCol
	shr	ax, 1
	mov	bx, ax
	shl	ax, 1
	add	ax, bx
	add	ax, 8
	cmp	bx, 4
	jb	@1
	inc	ax
@1:	cmp	bx, 12
	jb	@2
	inc	ax
@2:	cmp	bx, 8
	jb	@3
	inc	ax
	inc	ax
@3:	mov	dl, al
	test	CurCol, 1
	jz	@4
	inc	dl
@4:	call	GotoXY
	ret
UpdateCursorPos	endp


;
; 楤	exit
;
; 砭	室  ணࠬ, । ࠢ 樮 ⥬
;
;  室	al -  室
;
exit	proc	near
	mov	ah, 4Ch
	int	21h
	int	20h
	jmp	exit
exit	endp


code	ends
	end	start
